﻿UseSQLiteDatabase()
;http://forums.purebasic.com/english/viewtopic.php?f=13&t=42263&sid=f839d89efae3cf11fb79d54faa93af03&start=15
EnableExplicit

#WH_KEYBOARD_LL = 13
#INPUT_KEYBOARD = 1
#LLKHF_EXTENDED = $1
#LLKHF_ALTDOWN = $20
#KEYEVENTF_UNICODE = $4
#KEYEVENTF_SCANCODE = $8

Global myKeyhook

Procedure.l KeyProc(nCode.l,wParam.l,lParam.l)
  
  Protected keyInput.KBDLLHOOKSTRUCT
  Protected aret.l
  
  Static lwk.l,rwk.l
  
  CopyMemory(lparam,@keyinput,SizeOf(KBDLLHOOKSTRUCT))
  
  
  If nCode = #HC_ACTION
    
    If keyInput\vkCode=#VK_LWIN
      If wParam=#WM_KEYDOWN
        lwk=1
      Else
        lwk=0
      EndIf
    ElseIf keyInput\vkCode=#VK_RWIN
      If wParam=#WM_KEYDOWN
        rwk=1
      Else
        rwk=0
      EndIf
    EndIf
    ;     SetWindowTitle(0,Str(lwk)+"/"+Str(rwk))
    
    If wParam=#WM_KEYDOWN Or wParam = #WM_SYSKEYDOWN
      If (lwk Or rwk) And keyInput\vkCode=#VK_R
        ;Debug "win+R"
        HideWindow(1,0,#PB_Window_NoActivate)
        SetActiveGadget(2)
        aret = 1
      EndIf
    EndIf
    
    
    If Not aret
      aret = CallNextHookEx_(myKeyhook, nCode, wParam, lParam)
    EndIf
    
  Else
    aret = CallNextHookEx_(myKeyhook, nCode, wParam, lParam)
  EndIf
  
  ProcedureReturn aret
  
EndProcedure

Procedure SetHooks()
  Protected hInstance
  hInstance = GetModuleHandle_(0)
  If hInstance
    myKeyhook = SetWindowsHookEx_(#WH_KEYBOARD_LL, @KeyProc(),hInstance,0)
  Else
    MessageRequester("hook", "can't get module handle")
  EndIf       
  
EndProcedure

Procedure KillHooks()
  
  UnhookWindowsHookEx_(myKeyhook)
  myKeyHook = 0
EndProcedure


OpenWindow(1,0,0,140,20-4,"",#PB_Window_BorderLess|#PB_Window_ScreenCentered);|#PB_Window_Invisible)
Sethooks()

SetWindowColor(1,RGB(0,0,255/2))

SetWindowLongPtr_(WindowID(1), #GWL_EXSTYLE, GetWindowLongPtr_(WindowID(1), #GWL_EXSTYLE) | #WS_EX_LAYERED)
;Transparency
;SetLayeredWindowAttributes_(WindowID(1),0,156,#LWA_ALPHA)

SetWindowPos_(WindowID(1),#HWND_TOPMOST,WindowX(1),WindowY(1),WindowWidth(1),WindowHeight(1),#SWP_DRAWFRAME)

StringGadget(2, 0, 0, 120, 20, "", #PB_String_BorderLess|#ES_CENTER)
SetGadgetColor(2,#PB_Gadget_BackColor,0);$FF0000)
SetGadgetColor(2,#PB_Gadget_FrontColor,$00FFFF)
SetActiveGadget(2)

HideWindow(1,1)

;hicon.l=LoadIcon_(GetModuleHandle_(0),1)
AddSysTrayIcon (1, WindowID(1), LoadIcon_(GetModuleHandle_(0),1)) ; <<--- hier irgend ein 16X16 Icon nehmen 

DisableExplicit
If CreatePopupMenu(0) 
  ;     MenuItem(1, "setup") 
  ;     MenuBar() 
  MenuItem(2, "Quit") 
EndIf  


OpenDatabase(0, ":memory:", "", "")

DatabaseUpdate(0, "create table shorts(snid integer PRIMARY KEY AUTOINCREMENT, sho text, shopa text);")

If FileSize("launcher.txt")>=0
  If ReadFile(1,"launcher.txt")
    While Not Eof(1)
      s$=ReadString(1)
      If Mid(s$,1,1)<>";"
        p.l=FindString(s$,Chr(9))
        If p
          s1.s=Mid(s$,1,p-1)
          s1=ReplaceString(s1,"'","''")
          s2.s=Mid(s$,p+1)
          s2=ReplaceString(s2,"'","''")
          If Not DatabaseUpdate(0, "INSERT INTO shorts(sho,shopa) values ('"+s1+"','"+s2+"');")
            MessageRequester("Error", "Can't execute the query: "+DatabaseError())
          EndIf
        EndIf
      EndIf
    Wend
    CloseFile(1)
  Else
    MessageRequester("Launcher","no launcher.txt file!")
  EndIf
EndIf

Repeat
  ev=WaitWindowEvent()
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    ;Break
    HideWindow(1,1)
  EndIf
  
  If GetAsyncKeyState_(#VK_RETURN)=-32767
    s$=GetGadgetText(2)
    s$=ReplaceString(s$,"'","''")
    DatabaseQuery(0, "SELECT * FROM shorts where sho='"+s$+"'")
    NextDatabaseRow(0)
    s1.s=GetDatabaseString(0,2)
    If s1<>""
      SetGadgetText(2,"")
      HideWindow(1,1)
      RunProgram(s1)
    EndIf
    ;    Break
  EndIf
  
  Select ev
    Case #PB_Event_SysTray
      If EventType() = #PB_EventType_RightClick 
        DisplayPopupMenu(0, WindowID(1)) 
      EndIf
      
    Case #PB_Event_Menu;If EventID = #PB_Event_Menu ; <<-- PopUp Event 
      Select EventMenu() 
          ;           Case 1
          ;             HideWindow(0,0,#PB_Window_NoActivate)
          ;             SetFocus_(hwndHot)
        Case 2
          Break;Quit = 1 
      EndSelect 
      
    Case #PB_Event_CloseWindow;, #PB_Event_Gadget
      Break
    Case #WM_LBUTTONDOWN
      SendMessage_(WindowID(1), #WM_NCLBUTTONDOWN, #HTCAPTION , #Null)
  EndSelect
ForEver
KillHooks()
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 132
; FirstLine = 105
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = RunningMan.ico
; Executable = lau.exe